SoNode Class Reference
Node Classes

The SoNode class is the base class for nodes used in scene graphs. More...

`#include <Inventor/nodes/SoNode.h>`

Inheritance diagram for SoNode:

## Public Types

enum

NodeType {
INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 ,
INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 ,
COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 ,
COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 ,
COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000
}

## Public Member Functions

void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual const SoFieldData * | getFieldData (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
virtual SoType | getTypeId (void) const =0
| Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Protected Member Functions

| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Protected Attributes

SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn

## Static Protected Attributes

static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Additional Inherited Members

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }

## Detailed Description

The SoNode class is the base class for nodes used in scene graphs.

Coin is a retained mode 3D visualization library (built on top of the immediate mode OpenGL library). "Retained mode" means that instead of passing commands to draw graphics primitives directly to the renderer, you build up data structures which are rendered by the library on demand.

The node classes are the main "primitive" for building these data structures. In Coin, you build tree hierarchies made up of different node types: group nodes (for the tree structure layout of the other nodes), appearance nodes (for setting up materials, textures, etc), shape nodes (for the actual geometry), and nodes for lighting and camera positioning.

One common issue with newcomers to the API is that you should not and cannot use the C++ delete operator on nodes – the destructor is protected. This is because node instances are using a common technique for memory resource handling called "reference counting". Nodes are deleted (actually, they delete themselves) when their unref() method is called and the reference count goes to zero.

One important side-effect of this is that SoNode-derived classes should not be statically allocated, neither in static module memory nor on functions stack frames. SoNode-derived classes must always be allocated dynamically from the memory heap with the `new` operator (or else the scheme with self-destruction upon dereferencing to 0 would not work).

Usually application programmers won't manually ref() and unref() nodes a lot, because you pass the nodes directly to SoGroup::addChild() or So@Gui@Viewer::setSceneGraph() or something similar. These functions will ref() the nodes they are passed, and unref() them when they are finished with them.

Make sure you do ref() nodes that you keep pointers to so they aren't accidentally deleted prematurely due to an unref() call from within the library itself. If you haven't manually called ref() on a top level root node, it will then be deleted automatically. This code shows how to do it:

SoSeparator * root = new SoSeparator; // root's refcount starts out at zero
root->addChild(foo_node); // foo_node refcount is increased by 1
root->addChild(bar_node); // bar_node refcount +1
// increase refcount before passing it to setScenegraph(), to avoid
// premature destruction
root->ref();
myviewer->setSceneGraph(root); // root's refcount +1, is now 2
// [misc visualization and processing]
// myviewer will let go of its reference to the root node, thereby
// decreasing its reference count by 1
myviewer->setSceneGraph(NULL);
// root's refcount goes from +1 to 0, and it will self-destruct controllably
root->unref();
// avoid dangling pointer, in case "root" is attempted used again
// (not really necessary, but good for smoking out bugs early)
root = NULL;
SoBase::unref
void unref(void) const
Definition SoBase.cpp:530
SoBase::ref
void ref(void) const
Definition SoBase.cpp:478
SoGroup::addChild
virtual void addChild(SoNode *node)
Definition SoGroup.cpp:453
SoSeparator
The SoSeparator class is a state-preserving group node.
Definition SoSeparator.h:44

For full information and tutorial-style introductions to all API issues, see the "Inventor Mentor: Programming Object-Oriented 3D Graphics with Open Inventor" (ISBN 0-201-62495-8). It has detailed explanations on all the basic principles involved.

See specifically the section "References and Deletion" in Chapter 3 to learn about the reference counting techniques.

Often when using the Coin library, one is interested in making extensions to it. Of particular interest is setting up extension nodes, which are then traversed, rendered and otherwise used by the rest of the library as any internal node.

The Coin header file Inventor/nodes/SoSubNode.h includes a set of convenience macros for quick and easy construction of extension nodes. Here's a complete snippet of code which shows how to set up a skeleton framework for an extension node class:

#include <Inventor/nodes/SoWWWInline.h>
class MyWWWInline : public SoWWWInline {
SO_NODE_HEADER(MyWWWInline);
public:
static void initClass(void);
MyWWWInline(void);
protected:
virtual ~MyWWWInline();
};
SO_NODE_SOURCE(MyWWWInline);
MyWWWInline::MyWWWInline(void)
{
SO_NODE_CONSTRUCTOR(MyWWWInline);
}
MyWWWInline::~MyWWWInline()
{
}
void
MyWWWInline::initClass(void)
{
SO_NODE_INIT_CLASS(MyWWWInline, SoWWWInline, "SoWWWInline");
}
int
main(int argc, char ** argv)
{
SoDB::init();
MyWWWInline::initClass();
// [...]
return 0;
}
SoDB::init
static void init(void)
Definition SoDB.cpp:200
SoWWWInline
The SoWWWInline class is a node used to include data from an URL.
Definition SoWWWInline.h:57
SoWWWInline::initClass
static void initClass(void)
Sets up initialization for data common to all instances of this class, like submitting necessary info...
Definition SoWWWInline.cpp:255
SO_NODE_SOURCE
#define SO_NODE_SOURCE(classname)
Definition Coin_macros.dox:98
SO_NODE_HEADER
#define SO_NODE_HEADER(classname)
Definition Coin_macros.dox:50
SO_NODE_INIT_CLASS
#define SO_NODE_INIT_CLASS(classname, parentclass, parentname)
Definition Coin_macros.dox:73
SO_NODE_CONSTRUCTOR
#define SO_NODE_CONSTRUCTOR(classname)
Definition Coin_macros.dox:122

You can then override for instance the GLRender() method to have your new class render OpenGL geometry different from its superclass.

For extending the Coin library with your own classes, we strongly recommend that you make yourself acquainted with the excellent «The Inventor Toolmaker» book (ISBN 0-201-62493-1), which describes the tasks involved in detail. This book was written by the original SGI Inventor designers and explains many of the underlying design ideas, as well as having lots of hands-on examples on how to extend the Coin toolkit in ways that are true to the fundamental design ideas. («The Inventor Toolmaker» is also available at SGI's online library, at no cost. See Download The Inventor Toolmaker.) Reading the source code of the built-in classes in Coin should also prove very helpful.
For information about dynamic loading of extension nodes, see the documentation of SoType::fromName().

## Member Enumeration Documentation

## NodeType

enum SoNode::NodeType

Used to store node type.

Enumerator
INVENTOR | Specifies Inventor node type.
VRML1 | Node is VRML V1.0 compatible.
VRML2 | Node is from the VRML V2.0 specification.
INVENTOR_1 | Node was part of SGI Inventor version 1.
INVENTOR_2_0 | Node was part of SGI Inventor version 2.0.
INVENTOR_2_1 | Node was introduced with SGI / TGS Inventor version 2.1.
INVENTOR_2_5 | Node was introduced with TGS Inventor version 2.5.
INVENTOR_2_6 | Node was introduced with TGS Inventor version 2.6.
COIN_1_0 | Node was part of Coin version 1.0.
COIN_2_0 | Node was introduced with Coin 2.0.
EXTENSION | Node is a client code extension.
COIN_2_2 | Node was introduced with Coin 2.2.
COIN_2_3 | Node was introduced with Coin 2.3.
COIN_2_4 | Node was introduced with Coin 2.4.
INVENTOR_5_0 | Node was introduced with TGS Inventor version 5.0.
COIN_2_5 | Node was introduced with Coin 2.5.
COIN_3_0 | Node was introduced with Coin 3.0.
INVENTOR_6_0 | Node was introduced with TGS Inventor version 6.0.
COIN_4_0 | Node was introduced with Coin 4.0.

## Constructor & Destructor Documentation

## SoNode()

SoNode::SoNode | ( | void |  | ) |

protected

Default constructor, initializes node instance.

## ~SoNode()

SoNode::~SoNode | ( |  | ) |

protected virtual

Destructor.

## Member Function Documentation

## setOverride()

void SoNode::setOverride | ( | const SbBool | state | ) |

Set the override flag.

If this flag is `TRUE`, the field values of this node will override the field values of other nodes of the same type during scene graph traversal.

A common application for "override nodes" is to place them at the top of the tree as a convenient way to force e.g. a common draw style on the complete tree.

The override flag does not exist in the Inventor file format. This flag is in other words not persistent, and must be programmatically set. The rationale for this flag is for viewers to be able to control rendering style of the 3D models, so it would look stupid if some parts of certain models suddenly didn't adhere to the viewer mode.

## isOverride()

SbBool SoNode::isOverride | ( | void |  | ) | const

Return status of override flag.

See also
  setOverride()

## getCompatibilityTypes()

uint32_t SoNode::getCompatibilityTypes | ( | const SoType & | nodetype | ) |

static

Get the node compatibility mask for node type nodetype. The return value will be a bit mask of SoNode::NodeType flags, containing one or several flags.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since
  Coin 2.0

## setNodeType()

void SoNode::setNodeType | ( | const NodeType | type | ) |

Sets the node type for this node to type. Since some nodes should be handled differently in VRML1 vs. Inventor, this should be used to get correct behavior for those cases. The default node type is INVENTOR.

This method is an extension versus the Open Inventor API.

See also
  getNodeType()

## getNodeType()

SoNode::NodeType SoNode::getNodeType | ( | void |  | ) | const

Returns the node type set for this node.

This method is an extension versus the Open Inventor API.

See also
  setNodeType()

## copy()

SoNode * SoNode::copy | ( | SbBool | copyconnections = FALSE | ) | const

virtual

Make a duplicate of this node and return a pointer to the duplicate.

If this node is a group node, children are also copied and we return a pointer to the root of a full copy of the subgraph rooted here.

If copyconnections is `TRUE`, we also copy the connections to fields within this node (and ditto for any children and children's children etc.).

Note that this function has been made virtual in Coin, which is not the case in the original Open Inventor API. We may change this method back into being non-virtual again for major Coin versions after this, as it was made virtual more or less by mistake. So please don't write application code that depends on SoNode::copy() being virtual.

The reason this method should not be virtual is because this is not the function the application programmer should override in extension nodes if she needs some special behavior during a copy operation (like copying the value of internal data not exposed as fields).

For that purpose, override the copyContents() method. Your overridden copyContents() method should then both copy internal data as well as calling the parent superclass' copyContents() method for automatically handling of fields and other common data.

## affectsState()

SbBool SoNode::affectsState | ( | void |  | ) | const

virtual

Returns `TRUE` if the node could have any effect on the state during traversal.

If it returns `FALSE`, no data in the traversal state will change from the pre-traversal state to the post-traversal state. The SoSeparator node will for instance return `FALSE`, as it pushes and pops the state before and after traversal of its children. All SoShape nodes will also return `FALSE`, as just pushing out geometry data to the rendering engine won't affect the actual rendering state.

The default method returns `TRUE`, on a "better safe than sorry" philosophy.

Reimplemented in SoArray, SoMultipleCopy, SoNodeKitListPart, SoSceneKit, SoSeparator, SoShape, SoSwitch, SoVRMLLOD, SoVRMLParent, SoVRMLProximitySensor, SoVRMLShape, SoVRMLSwitch, and SoVRMLTouchSensor.

## doAction()

void SoNode::doAction | ( | SoAction * | action | ) |

virtual

This function performs the typical operation of a node for any action.

Reimplemented in SoAntiSquish, SoArray, SoBaseColor, SoBaseKit, SoBumpMap, SoBumpMapCoordinate, SoBumpMapTransform, SoCacheHint, SoCallback, SoCamera, SoClipPlane, SoClipPlaneManip, SoComplexity, SoCoordinate3, SoCoordinate4, SoDirectionalLightManip, SoDrawStyle, SoFile, SoFont, SoFontStyle, SoGeoCoordinate, SoGeoLocation, SoGeoOrigin, SoGroup, SoLevelOfDetail, SoLightModel, SoLOD, SoMaterial, SoMaterialBinding, SoMatrixTransform, SoMultipleCopy, SoNodeKitListPart, SoNormal, SoNormalBinding, SoPackedColor, SoPathSwitch, SoPickStyle, SoPointLightManip, SoPolygonOffset, SoProfile, SoProfileCoordinate2, SoProfileCoordinate3, SoResetTransform, SoRotation, SoRotationXYZ, SoScale, SoSceneTexture2, SoSceneTextureCubeMap, SoSeparator, SoShapeHints, SoSpotLightManip, SoSurroundScale, SoSwitch, SoTexture2, SoTexture2Transform, SoTexture3, SoTexture3Transform, SoTexture, SoTextureCombine, SoTextureCoordinate2, SoTextureCoordinate3, SoTextureCoordinateBinding, SoTextureCoordinateCube, SoTextureCoordinateCylinder, SoTextureCoordinateDefault, SoTextureCoordinateEnvironment, SoTextureCoordinateNormalMap, SoTextureCoordinateObject, SoTextureCoordinatePlane, SoTextureCoordinateReflectionMap, SoTextureCoordinateSphere, SoTextureCubeMap, SoTextureMatrixTransform, SoTextureUnit, SoTransform, SoTransformManip, SoTransformSeparator, SoTranslation, SoTransparencyType, SoUnits, SoVertexAttribute, SoVertexAttributeBinding, SoVertexProperty, SoVRMLAppearance, SoVRMLBillboard, SoVRMLColor, SoVRMLCoordinate, SoVRMLFontStyle, SoVRMLGroup, SoVRMLImageTexture, SoVRMLInline, SoVRMLLOD, SoVRMLMaterial, SoVRMLNormal, SoVRMLParent, SoVRMLPixelTexture, SoVRMLProximitySensor, SoVRMLScript, SoVRMLShape, SoVRMLSwitch, SoVRMLTextureCoordinate, SoVRMLTextureTransform, SoVRMLTransform, SoVRMLVertexLine, SoVRMLVertexPoint, SoVRMLVertexShape, and SoWWWInline.

## GLRender()

void SoNode::GLRender | ( | SoGLRenderAction * | action | ) |

virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented in SoAlphaTest, SoAnnotation, SoAntiSquish, SoArray, SoAsciiText, SoBaseColor, SoBaseKit, SoBumpMap, SoBumpMapCoordinate, SoBumpMapTransform, SoCacheHint, SoCallback, SoCamera, SoClipPlane, SoClipPlaneManip, SoColorIndex, SoComplexity, SoCone, SoCoordinate3, SoCoordinate4, SoCube, SoCylinder, SoDepthBuffer, SoDirectionalLight, SoDirectionalLightManip, SoDragger, SoDrawStyle, SoEnvironment, SoFaceSet, SoFile, SoFont, SoFontStyle, SoGeoCoordinate, SoGeoLocation, SoGeometryShader, SoGeoOrigin, SoGroup, SoImage, SoIndexedFaceSet, SoIndexedLineSet, SoIndexedMarkerSet, SoIndexedNurbsCurve, SoIndexedNurbsSurface, SoIndexedPointSet, SoIndexedTriangleStripSet, SoLevelOfDetail, SoLightModel, SoLineSet, SoLOD, SoMarkerSet, SoMaterial, SoMaterialBinding, SoMatrixTransform, SoMultipleCopy, SoNodeKitListPart, SoNormal, SoNormalBinding, SoNurbsCurve, SoNurbsSurface, SoPackedColor, SoPathSwitch, SoPointLight, SoPointLightManip, SoPointSet, SoPolygonOffset, SoProfile, SoProfileCoordinate2, SoProfileCoordinate3, SoProfilerStats, SoQuadMesh, SoResetTransform, SoRotation, SoRotationXYZ, SoScale, SoSceneTexture2, SoSceneTextureCubeMap, SoSeparator, SoShaderObject, SoShaderProgram, SoShadowCulling, SoShadowDirectionalLight, SoShadowSpotLight, SoShadowStyle, SoShape, SoShapeHints, SoSphere, SoSpotLight, SoSpotLightManip, SoSurroundScale, SoSwitch, SoTabPlaneDragger, SoText2, SoText3, SoTexture2, SoTexture2Transform, SoTexture3, SoTexture3Transform, SoTexture, SoTextureCombine, SoTextureCoordinate2, SoTextureCoordinate3, SoTextureCoordinateBinding, SoTextureCoordinateCube, SoTextureCoordinateCylinder, SoTextureCoordinateDefault, SoTextureCoordinateEnvironment, SoTextureCoordinateNormalMap, SoTextureCoordinateObject, SoTextureCoordinatePlane, SoTextureCoordinateReflectionMap, SoTextureCoordinateSphere, SoTextureCubeMap, SoTextureMatrixTransform, SoTextureScalePolicy, SoTextureUnit, SoTransform, SoTransformManip, SoTransformSeparator, SoTranslation, SoTransparencyType, SoTriangleStripSet, SoUnits, SoVertexAttribute, SoVertexAttributeBinding, SoVertexProperty, SoVRMLAppearance, SoVRMLBackground, SoVRMLBillboard, SoVRMLBox, SoVRMLCollision, SoVRMLColor, SoVRMLCone, SoVRMLCoordinate, SoVRMLCylinder, SoVRMLDirectionalLight, SoVRMLElevationGrid, SoVRMLExtrusion, SoVRMLFog, SoVRMLFontStyle, SoVRMLGroup, SoVRMLImageTexture, SoVRMLIndexedFaceSet, SoVRMLIndexedLineSet, SoVRMLInline, SoVRMLLight, SoVRMLLOD, SoVRMLMaterial, SoVRMLMovieTexture, SoVRMLNavigationInfo, SoVRMLNormal, SoVRMLPixelTexture, SoVRMLPointLight, SoVRMLPointSet, SoVRMLProximitySensor, SoVRMLScript, SoVRMLShape, SoVRMLSphere, SoVRMLSpotLight, SoVRMLSwitch, SoVRMLText, SoVRMLTexture, SoVRMLTextureCoordinate, SoVRMLTextureTransform, SoVRMLVertexLine, SoVRMLVertexPoint, SoVRMLVertexShape, SoVRMLViewpoint, SoVRMLVisibilitySensor, and SoWWWInline.

## GLRenderBelowPath()

void SoNode::GLRenderBelowPath | ( | SoGLRenderAction * | action | ) |

virtual

Implements the SoAction::BELOW_PATH traversal method for the rendering action.

Reimplemented in SoAnnotation, SoExtSelection, SoGeoSeparator, SoLocateHighlight, SoLOD, SoSeparator, SoShadowGroup, SoVRMLBillboard, SoVRMLGroup, SoVRMLLOD, and SoVRMLTransform.

## GLRenderInPath()

void SoNode::GLRenderInPath | ( | SoGLRenderAction * | action | ) |

virtual

Implements the SoAction::IN_PATH traversal method for the rendering action.

Reimplemented in SoAnnotation, SoGeoSeparator, SoLocateHighlight, SoLOD, SoSeparator, SoShadowGroup, SoVRMLBillboard, SoVRMLGroup, SoVRMLLOD, and SoVRMLTransform.

## GLRenderOffPath()

void SoNode::GLRenderOffPath | ( | SoGLRenderAction * | action | ) |

virtual

Implements the SoAction::OFF_PATH traversal method for the rendering action.

Reimplemented in SoAnnotation, SoLOD, SoSeparator, SoVRMLBillboard, SoVRMLGroup, and SoVRMLLOD.

## callback()

void SoNode::callback | ( | SoCallbackAction * | action | ) |

virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented in SoAntiSquish, SoArray, SoBaseColor, SoBaseKit, SoBumpMap, SoBumpMapCoordinate, SoBumpMapTransform, SoCacheHint, SoCallback, SoCamera, SoClipPlane, SoClipPlaneManip, SoComplexity, SoCoordinate3, SoCoordinate4, SoDirectionalLightManip, SoDragger, SoDrawStyle, SoEnvironment, SoFile, SoFont, SoFontStyle, SoGeoCoordinate, SoGeoLocation, SoGeoOrigin, SoGeoSeparator, SoGroup, SoLevelOfDetail, SoLight, SoLightModel, SoLOD, SoMaterial, SoMaterialBinding, SoMatrixTransform, SoMultipleCopy, SoNodeKitListPart, SoNormal, SoNormalBinding, SoPackedColor, SoPathSwitch, SoPickStyle, SoPointLightManip, SoPolygonOffset, SoProfile, SoProfileCoordinate2, SoProfileCoordinate3, SoProfilerStats, SoResetTransform, SoRotation, SoRotationXYZ, SoScale, SoSceneTexture2, SoSceneTextureCubeMap, SoSeparator, SoShape, SoShapeHints, SoSpotLightManip, SoSurroundScale, SoSwitch, SoTexture2, SoTexture2Transform, SoTexture3, SoTexture3Transform, SoTexture, SoTextureCombine, SoTextureCoordinate2, SoTextureCoordinate3, SoTextureCoordinateBinding, SoTextureCoordinateCube, SoTextureCoordinateCylinder, SoTextureCoordinateDefault, SoTextureCoordinateEnvironment, SoTextureCoordinateNormalMap, SoTextureCoordinateObject, SoTextureCoordinatePlane, SoTextureCoordinateReflectionMap, SoTextureCoordinateSphere, SoTextureCubeMap, SoTextureMatrixTransform, SoTextureUnit, SoTransform, SoTransformManip, SoTransformSeparator, SoTranslation, SoTransparencyType, SoUnits, SoVertexAttributeBinding, SoVertexProperty, SoVRMLAppearance, SoVRMLBillboard, SoVRMLColor, SoVRMLCoordinate, SoVRMLFontStyle, SoVRMLGroup, SoVRMLImageTexture, SoVRMLInline, SoVRMLLOD, SoVRMLMaterial, SoVRMLNormal, SoVRMLPixelTexture, SoVRMLProximitySensor, SoVRMLScript, SoVRMLShape, SoVRMLSwitch, SoVRMLTextureCoordinate, SoVRMLTextureTransform, SoVRMLTransform, SoVRMLVertexLine, SoVRMLVertexPoint, SoVRMLVertexShape, and SoWWWInline.

## getBoundingBox()

void SoNode::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) |

virtual

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented in SoAntiSquish, SoArray, SoBaseKit, SoBlinker, SoCacheHint, SoCallback, SoCamera, SoCenterballDragger, SoClipPlaneManip, SoComplexity, SoCoordinate3, SoCoordinate4, SoDirectionalLightManip, SoDragger, SoFile, SoFont, SoFontStyle, SoGeoCoordinate, SoGeoLocation, SoGeoOrigin, SoGeoSeparator, SoGroup, SoIndexedLineSet, SoIndexedNurbsCurve, SoIndexedPointSet, SoLevelOfDetail, SoLineSet, SoLOD, SoMatrixTransform, SoMultipleCopy, SoNodeKitListPart, SoNurbsCurve, SoPathSwitch, SoPointLightManip, SoPointSet, SoProfile, SoProfileCoordinate2, SoProfileCoordinate3, SoProfilerStats, SoResetTransform, SoRotation, SoRotationXYZ, SoScale, SoSeparator, SoShape, SoShapeHints, SoSpotLightManip, SoSurroundScale, SoSwitch, SoTextureUnit, SoTransform, SoTransformManip, SoTransformSeparator, SoTranslation, SoUnits, SoVertexProperty, SoVRMLBillboard, SoVRMLCoordinate, SoVRMLFontStyle, SoVRMLGroup, SoVRMLIndexedLineSet, SoVRMLInline, SoVRMLLOD, SoVRMLPointSet, SoVRMLProximitySensor, SoVRMLScript, SoVRMLShape, SoVRMLSwitch, SoVRMLTransform, SoVRMLVertexLine, SoVRMLVertexPoint, SoVRMLVertexShape, and SoWWWInline.

## getMatrix()

void SoNode::getMatrix | ( | SoGetMatrixAction * | action | ) |

virtual

Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented in SoAntiSquish, SoArray, SoBaseKit, SoBumpMapTransform, SoCallback, SoCamera, SoCenterballDragger, SoClipPlaneManip, SoDirectionalLightManip, SoDragger, SoFile, SoGeoLocation, SoGeoOrigin, SoGeoSeparator, SoGroup, SoMatrixTransform, SoMultipleCopy, SoNodeKitListPart, SoPathSwitch, SoPointLightManip, SoProfilerStats, SoResetTransform, SoRotation, SoRotationXYZ, SoScale, SoSeparator, SoSpotLightManip, SoSurroundScale, SoSwitch, SoTexture2Transform, SoTexture3Transform, SoTextureMatrixTransform, SoTextureUnit, SoTransform, SoTransformManip, SoTransformSeparator, SoTranslation, SoUnits, SoVRMLBillboard, SoVRMLGroup, SoVRMLInline, SoVRMLSwitch, SoVRMLTextureTransform, SoVRMLTransform, and SoWWWInline.

## handleEvent()

void SoNode::handleEvent | ( | SoHandleEventAction * | action | ) |

virtual

Action method for SoHandleEventAction.

Inspects the event data from action, and processes it if it is something which this node should react to.

Nodes influencing relevant state variables for how event handling is done also override this method.

Reimplemented in SoArray, SoBaseKit, SoCallback, SoCamera, SoClipPlaneManip, SoDirectionalLightManip, SoDragger, SoEventCallback, SoExtSelection, SoFile, SoGroup, SoLocateHighlight, SoMultipleCopy, SoNodeKitListPart, SoNodeVisualize, SoPathSwitch, SoPointLightManip, SoProfilerStats, SoSelection, SoSeparator, SoSpotLightManip, SoSwitch, SoTransformManip, SoVRMLAnchor, SoVRMLDragSensor, SoVRMLInline, SoVRMLScript, SoVRMLSwitch, SoVRMLTimeSensor, SoVRMLTouchSensor, SoWWWAnchor, and SoWWWInline.

## pick()

void SoNode::pick | ( | SoPickAction * | action | ) |

virtual

Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented in SoAntiSquish, SoArray, SoBumpMapCoordinate, SoBumpMapTransform, SoCacheHint, SoCallback, SoClipPlane, SoClipPlaneManip, SoComplexity, SoCoordinate3, SoCoordinate4, SoDirectionalLightManip, SoFile, SoFont, SoFontStyle, SoGeoCoordinate, SoGeoLocation, SoGeoOrigin, SoGroup, SoMaterialBinding, SoMatrixTransform, SoMultipleCopy, SoNodeKitListPart, SoNormal, SoNormalBinding, SoPathSwitch, SoPickStyle, SoPointLightManip, SoProfile, SoProfileCoordinate2, SoProfileCoordinate3, SoProfilerStats, SoResetTransform, SoRotation, SoRotationXYZ, SoScale, SoShapeHints, SoSpotLightManip, SoSurroundScale, SoSwitch, SoTexture2Transform, SoTexture3Transform, SoTextureCombine, SoTextureCoordinate2, SoTextureCoordinate3, SoTextureCoordinateBinding, SoTextureCoordinateCube, SoTextureCoordinateCylinder, SoTextureCoordinateDefault, SoTextureCoordinateEnvironment, SoTextureCoordinateNormalMap, SoTextureCoordinateObject, SoTextureCoordinatePlane, SoTextureCoordinateReflectionMap, SoTextureCoordinateSphere, SoTextureMatrixTransform, SoTextureUnit, SoTransform, SoTransformManip, SoTransformSeparator, SoTranslation, SoUnits, SoVertexAttributeBinding, SoVertexProperty, SoVRMLBillboard, SoVRMLCoordinate, SoVRMLFontStyle, SoVRMLInline, SoVRMLNormal, SoVRMLScript, SoVRMLSwitch, SoVRMLTextureCoordinate, SoVRMLTextureTransform, SoVRMLVertexLine, SoVRMLVertexPoint, SoVRMLVertexShape, and SoWWWInline.

## rayPick()

void SoNode::rayPick | ( | SoRayPickAction * | action | ) |

virtual

Action method for SoRayPickAction.

Checks the ray specification of the action and tests for intersection with the data of the node.

Nodes influencing relevant state variables for how picking is done also override this method.

Reimplemented in SoBaseKit, SoBumpMap, SoCamera, SoCone, SoCube, SoCylinder, SoDragger, SoGeoSeparator, SoImage, SoIndexedNurbsCurve, SoIndexedNurbsSurface, SoLevelOfDetail, SoLOD, SoNurbsCurve, SoNurbsSurface, SoProfilerStats, SoSceneTexture2, SoSceneTextureCubeMap, SoSeparator, SoShape, SoSphere, SoText2, SoTexture2, SoTextureCubeMap, SoVRMLBox, SoVRMLCone, SoVRMLCylinder, SoVRMLElevationGrid, SoVRMLGroup, SoVRMLImageTexture, SoVRMLLOD, SoVRMLPixelTexture, SoVRMLProximitySensor, SoVRMLShape, SoVRMLSphere, and SoVRMLTransform.

## search()

void SoNode::search | ( | SoSearchAction * | action | ) |

virtual

Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction – if any of the requested criteria is a miss, the search is not deemed successful for the node.

See also
  SoSearchAction

Reimplemented in SoArray, SoBaseKit, SoCallback, SoClipPlaneManip, SoDirectionalLightManip, SoDragger, SoFile, SoGroup, SoMultipleCopy, SoNodeKitListPart, SoPathSwitch, SoPointLightManip, SoProfilerStats, SoSeparator, SoShaderObject, SoShaderProgram, SoSpotLightManip, SoSwitch, SoTransformManip, SoVRMLAppearance, SoVRMLBillboard, SoVRMLGeometry, SoVRMLGroup, SoVRMLInline, SoVRMLLOD, SoVRMLParent, SoVRMLShape, SoVRMLSwitch, and SoWWWInline.

## write()

void SoNode::write | ( | SoWriteAction * | action | ) |

virtual

Action method for SoWriteAction.

Writes out a node object, and any connected nodes, engines etc, if necessary.

Reimplemented in SoBaseKit, SoBlinker, SoCallback, SoDragger, SoGroup, SoPendulum, SoProfilerStats, SoProto, SoProtoInstance, SoSceneTexture2, SoShuttle, SoSwitch, SoVertexAttribute, SoVertexShape, SoVRMLGroup, SoVRMLLOD, SoVRMLParent, SoVRMLScript, SoVRMLShape, SoVRMLSwitch, and SoVRMLTimeSensor.

## audioRender()

void SoNode::audioRender | ( | SoAudioRenderAction * | action | ) |

virtual

Action method for SoAudioRenderAction.

Does common processing for SoAudioRenderAction action instances.

Reimplemented in SoArray, SoCamera, SoFile, SoGroup, SoLevelOfDetail, SoListener, SoLOD, SoMultipleCopy, SoPathSwitch, SoProfilerStats, SoSeparator, SoSwitch, SoTransformSeparator, SoVRMLGroup, SoVRMLLOD, SoVRMLSound, SoVRMLSwitch, SoVRMLTransform, and SoWWWInline.

## getPrimitiveCount()

void SoNode::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) |

virtual

Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented in SoArray, SoAsciiText, SoBaseKit, SoCallback, SoCamera, SoComplexity, SoCone, SoCoordinate3, SoCoordinate4, SoCube, SoCylinder, SoDragger, SoFaceSet, SoFile, SoFont, SoFontStyle, SoGeoCoordinate, SoGeoLocation, SoGeoOrigin, SoGeoSeparator, SoGroup, SoImage, SoIndexedFaceSet, SoIndexedLineSet, SoIndexedNurbsCurve, SoIndexedNurbsSurface, SoIndexedPointSet, SoIndexedTriangleStripSet, SoLineSet, SoLOD, SoMarkerSet, SoMaterialBinding, SoMatrixTransform, SoMultipleCopy, SoNodeKitListPart, SoNormal, SoNormalBinding, SoNurbsCurve, SoNurbsSurface, SoPathSwitch, SoPointSet, SoProfile, SoProfileCoordinate2, SoProfileCoordinate3, SoProfilerStats, SoQuadMesh, SoResetTransform, SoRotation, SoRotationXYZ, SoScale, SoSeparator, SoShape, SoSphere, SoSwitch, SoText2, SoText3, SoTransform, SoTransformSeparator, SoTranslation, SoTriangleStripSet, SoUnits, SoVertexAttributeBinding, SoVertexProperty, SoVRMLBox, SoVRMLCone, SoVRMLCylinder, SoVRMLElevationGrid, SoVRMLExtrusion, SoVRMLFontStyle, SoVRMLGroup, SoVRMLIndexedFaceSet, SoVRMLIndexedLineSet, SoVRMLInline, SoVRMLLOD, SoVRMLNormal, SoVRMLParent, SoVRMLShape, SoVRMLSphere, SoVRMLText, SoVRMLTextureCoordinate, SoVRMLTransform, SoVRMLVertexPoint, and SoWWWInline.

## grabEventsSetup()

void SoNode::grabEventsSetup | ( | void |  | ) |

virtual

Called from SoHandleEventAction::setGrabber() to notify a node when it becomes the node where all events are sent.

Reimplemented in SoDragger.

## grabEventsCleanup()

void SoNode::grabEventsCleanup | ( | void |  | ) |

virtual

Called from SoHandleEventAction to notify a node when it looses status as the node where events are sent.

Reimplemented in SoDragger.

## startNotify()

void SoNode::startNotify | ( | void |  | ) |

virtual

This is the method which starts the notification sequence after changes.

At the end of a notification sequence, all "immediate" sensors (i.e. sensors set up with a zero priority) are triggered.

Reimplemented from SoBase.

## notify()

void SoNode::notify | ( | SoNotList * | l | ) |

virtual

Notifies all auditors for this instance when changes are made.

Reimplemented from SoFieldContainer.

Reimplemented in SoAsciiText, SoBlinker, SoBumpMap, SoImage, SoIndexedLineSet, SoIndexedPointSet, SoLevelOfDetail, SoLOD, SoMaterial, SoNodeEngine, SoPackedColor, SoProfilerStats, SoSceneTexture2, SoSceneTextureCubeMap, SoSeparator, SoShadowGroup, SoShape, SoSwitch, SoText3, SoTexture2, SoTexture3, SoTextureCubeMap, SoVertexAttribute, SoVertexProperty, SoVertexShape, SoVRMLAppearance, SoVRMLBillboard, SoVRMLCollision, SoVRMLElevationGrid, SoVRMLExtrusion, SoVRMLGeometry, SoVRMLGroup, SoVRMLIndexedLine, SoVRMLIndexedLineSet, SoVRMLIndexedShape, SoVRMLLOD, SoVRMLParent, SoVRMLPixelTexture, SoVRMLProximitySensor, SoVRMLScript, SoVRMLShape, SoVRMLSwitch, SoVRMLText, SoVRMLTimeSensor, SoVRMLTouchSensor, SoVRMLTransform, SoVRMLVertexLine, SoVRMLVertexPoint, and SoVRMLVertexShape.

## getNodeId()

SbUniqueId SoNode::getNodeId | ( | void |  | ) | const

This returns the node's current unique identification number. It is unlikely that application programmers will ever need use this method from client application code, unless working with extensions to the core library (and probably not even then).

The id number is only valid for as long as the node is kept unchanged – upon any kind of change the internal id will be updated (in the notify() method), and the old id number forgotten.

The technique described above plays an important role in the way internal scene graph caches are set up and invalidated.

See also
  SoNode::getNextNodeId()

## getChildren()

SoChildList * SoNode::getChildren | ( | void |  | ) | const

virtual

Returns list of children for this node.

Reimplemented in SoBaseKit, SoClipPlaneManip, SoDirectionalLightManip, SoFile, SoGroup, SoNodeKitListPart, SoPointLightManip, SoSpotLightManip, SoTransformManip, SoVRMLAppearance, SoVRMLGeometry, SoVRMLInline, SoVRMLLOD, SoVRMLParent, SoVRMLShape, SoVRMLSwitch, SoVRMLText, and SoWWWInline.

## writeInstance()

void SoNode::writeInstance | ( | SoOutput * | out | ) |

virtual

Writes all the fields contained in this instance to the output stream within out.

This method is solely called from the write methods of fields.

Either from SoField if the write is done because of a field-to-field connection, or from one of the fields which may actually write SoFieldContainer instances, i.e. SoSFNode, SoMFNode, SoSFEngine, SoMFEngine, SoSFPath and SoMFPath.

This method, in addition to the ordinary write() method of SoNode, needs to be present since the fields don't have a write action instance in their writeValue() method, and writeInstance() will create a new SoWriteAction and call continueToApply() on it.

Reimplemented from SoFieldContainer.

Reimplemented in SoNodeEngine.

## addToCopyDict()

SoNode * SoNode::addToCopyDict | ( | void |  | ) | const

virtual

Add a copy of this node and (recursively) all children to the copy dictionary of SoFieldContainer if this has not already been done.

Used internally during copy operations.

Reimplemented in SoBaseKit.

## copyContents()

void SoNode::copyContents | ( | const SoFieldContainer * | from,
|  | SbBool | copyconnections )

virtual

Makes a deep copy of all data of from into this instance, except external scene graph references if copyconnections is `FALSE`.

This is the method that should be overridden by extension node / engine / dragger / whatever subclasses which need to account for internal data that are not handled automatically.

For copying nodes from application code, you should not invoke this function directly, but rather call the SoNode::copy() function:

SoNode * mynewnode = templatenode->copy();
SoNode::SoNode
SoNode(void)
Definition SoNode.cpp:417

The same also goes for engines.

Make sure that when you override the copyContents() method in your extension class that you also make it call upwards to its parent superclass in the inheritance hierarchy, as copyContents() in for instance SoNode and SoFieldContainer does important work. It should go something like this:

void
MyCoinExtensionNode::copyContents(const SoFieldContainer * from,
SbBool copyconnections)
{
// let parent superclasses do their thing (copy fields, copy
// instance name, etc.)
SoNode::copyContents(from, copyconnections);
// [..then copy internal data..]
}
SoFieldContainer::SoFieldContainer
SoFieldContainer(void)
Definition SoFieldContainer.cpp:133
SoNode::copyContents
virtual void copyContents(const SoFieldContainer *from, SbBool copyconnections)
Definition SoNode.cpp:1483

Reimplemented from SoFieldContainer.

Reimplemented in SoBaseKit, SoCallback, SoClipPlaneManip, SoDirectionalLightManip, SoFile, SoGroup, SoInteractionKit, SoNodeKitListPart, SoPointLightManip, SoRotateCylindricalDragger, SoRotateSphericalDragger, SoSpotLightManip, SoTransformManip, SoVertexAttribute, SoVRMLAppearance, SoVRMLGeometry, SoVRMLLOD, SoVRMLParent, SoVRMLScript, SoVRMLShape, SoVRMLSwitch, and SoWWWInline.

## copyThroughConnection()

SoFieldContainer * SoNode::copyThroughConnection | ( | void |  | ) | const

virtual

Return copy of this instance.

Note: default implementation just returns `this` pointer, SoNode and SoEngine overrides this method to return the pointer to the actual copy.

Reimplemented from SoFieldContainer.

## getClassTypeId()

SoType SoNode::getClassTypeId | ( | void |  | ) |

static

This static method returns the SoType object associated with objects of this class.

## getByName() [1/2]

SoNode * SoNode::getByName | ( | const SbName & | name | ) |

static

Returns the last node that was registered under name.

See also
  SoBase::setName()

## getByName() [2/2]

int SoNode::getByName | ( | const SbName & | name,
|  | SoNodeList & | l )

static

Finds all nodes with name and appends them to the l node list. Returns the number of nodes with the specified name.

See also
  SoBase::setName()

## initClasses()

void SoNode::initClasses | ( | void |  | ) |

static

Initialize all the node classes of Coin.

## getNextNodeId()

SbUniqueId SoNode::getNextNodeId | ( | void |  | ) |

static

Return the next unique identification number to be assigned upon node construction or change. It is unlikely that application programmers will ever need use this method from client application code, unless working with extensions to the core library (and probably not even then).

See also
  SoNode::getNodeId

## getActionMethodIndex()

int SoNode::getActionMethodIndex | ( | const SoType | type | ) |

static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## getBoundingBoxS()

void SoNode::getBoundingBoxS | ( | SoAction * | action,
|  | SoNode * | node )

static

This is a static "helper" method registered with the action, and used for calling the SoNode::getBoundingBox() virtual method which does the real work.

## GLRenderS()

void SoNode::GLRenderS | ( | SoAction * | action,
|  | SoNode * | node )

static

This is a static "helper" method registered with the action, and used for calling the SoNode::GLRender() virtual method which does the real work.

## callbackS()

void SoNode::callbackS | ( | SoAction * | action,
|  | SoNode * | node )

static

This is a static "helper" method registered with the action, and used for calling the SoNode::callback() virtual method which does the real work.

## getMatrixS()

void SoNode::getMatrixS | ( | SoAction * | action,
|  | SoNode * | node )

static

This is a static "helper" method registered with the action, and used for calling the SoNode::getMatrix() virtual method which does the real work.

## handleEventS()

void SoNode::handleEventS | ( | SoAction * | action,
|  | SoNode * | node )

static

This is a static "helper" method registered with the action, and used for calling the SoNode::handleEvent() virtual method which does the real work.

## pickS()

void SoNode::pickS | ( | SoAction * | action,
|  | SoNode * | node )

static

This is a static "helper" method registered with the action, and used for calling the SoNode::pick() virtual method which does the real work.

## rayPickS()

void SoNode::rayPickS | ( | SoAction * | action,
|  | SoNode * | node )

static

This is a static "helper" method registered with the action, and used for calling the SoNode::rayPick() virtual method which does the real work.

## searchS()

void SoNode::searchS | ( | SoAction * | action,
|  | SoNode * | node )

static

This is a static "helper" method registered with the action, and used for calling the SoNode::search() virtual method which does the real work.

## writeS()

void SoNode::writeS | ( | SoAction * | action,
|  | SoNode * | node )

static

This is a static "helper" method registered with the action, and used for calling the SoNode::write() virtual method which does the real work.

## audioRenderS()

void SoNode::audioRenderS | ( | SoAction * | action,
|  | SoNode * | node )

static

This is a static "helper" method registered with the action, and used for calling the SoNode::audioRender() virtual method which does the real work.

## getPrimitiveCountS()

void SoNode::getPrimitiveCountS | ( | SoAction * | action,
|  | SoNode * | node )

static

This is a static "helper" method registered with the action, and used for calling the SoNode::getPrimitiveCount() virtual method which does the real work.

## readInstance()

SbBool SoNode::readInstance | ( | SoInput * | in,
|  | unsigned short | flags )

protected virtual

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistent representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went OK or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoFieldContainer.

Reimplemented in SoBaseKit, SoBumpMap, SoFile, SoGroup, SoImage, SoInteractionKit, SoNodeEngine, SoNodeKitListPart, SoNormalBinding, SoProto, SoProtoInstance, SoSeparator, SoShaderObject, SoTexture2, SoTexture3, SoTextureCoordinateBinding, SoTextureCubeMap, SoVertexAttribute, SoVRMLBackground, SoVRMLImageTexture, SoVRMLLOD, SoVRMLParent, SoVRMLPixelTexture, SoVRMLSwitch, and SoWWWInline.

## getFieldDataPtr()

const SoFieldData ** SoNode::getFieldDataPtr | ( | void |  | ) |

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## setNextActionMethodIndex()

void SoNode::setNextActionMethodIndex | ( | int | index | ) |

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Only in TGS Inventor on Win32 – to avoid needing to export the nextActionMethodIndex member, see SoNode.h for more information.

## getNextActionMethodIndex()

int SoNode::getNextActionMethodIndex | ( | void |  | ) |

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Only in TGS Inventor on Win32 – to avoid needing to export the nextActionMethodIndex member, see SoNode.h for more information.

## incNextActionMethodIndex()

void SoNode::incNextActionMethodIndex | ( | void |  | ) |

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Only in TGS Inventor on Win32 – to avoid needing to export the nextActionMethodIndex member, see SoNode.h for more information.

## setCompatibilityTypes()

void SoNode::setCompatibilityTypes | ( | const SoType & | nodetype,
|  | const uint32_t | bitmask )

static protected

Set the node compatibility mask for node type nodetype. The mask specifies for which file formats the node is supported.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

See also
  getCompatibilityMode()

Since
  Coin 2.0

## Member Data Documentation

## uniqueId

SbUniqueId SoNode::uniqueId

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## nextUniqueId

SbUniqueId SoNode::nextUniqueId = 1

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## nextActionMethodIndex

int SoNode::nextActionMethodIndex = 0

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoNode.h
- SoNode.cpp